From f8ed07327b5217c3e63b44597dc026f95156bdbd Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 30 2020 01:23:14 +0000
Subject: [PATCH 483/2232] Split cxx runtime and build components


---

diff --git a/BUCK b/BUCK
index 6a9870e..2339f71 100644
--- a/BUCK
+++ b/BUCK
@@ -5,19 +5,13 @@ rust_library(
     deps = [
         ":core",
         ":macro",
-        "//third-party:anyhow",
-        "//third-party:cc",
-        "//third-party:codespan-reporting",
         "//third-party:link-cplusplus",
-        "//third-party:proc-macro2",
-        "//third-party:quote",
-        "//third-party:syn",
     ],
 )
 
 rust_binary(
     name = "codegen",
-    srcs = glob(["cmd/src/**"]),
+    srcs = glob(["gen/cmd/src/**"]),
     crate = "cxxbridge",
     visibility = ["PUBLIC"],
     deps = [
@@ -52,3 +46,17 @@ rust_library(
         "//third-party:syn",
     ],
 )
+
+rust_library(
+    name = "build",
+    srcs = glob(["gen/build/src/**"]),
+    visibility = ["PUBLIC"],
+    deps = [
+        "//third-party:anyhow",
+        "//third-party:cc",
+        "//third-party:codespan-reporting",
+        "//third-party:proc-macro2",
+        "//third-party:quote",
+        "//third-party:syn",
+    ],
+)
diff --git a/BUILD b/BUILD
index 2eea8c7..d63fea7 100644
--- a/BUILD
+++ b/BUILD
@@ -3,25 +3,18 @@ load("//tools/bazel:rust.bzl", "rust_binary", "rust_library")
 rust_library(
     name = "cxx",
     srcs = glob(["src/**/*.rs"]),
-    data = ["src/gen/include/cxx.h"],
     visibility = ["//visibility:public"],
     deps = [
         ":core-lib",
         ":cxxbridge-macro",
-        "//third-party:anyhow",
-        "//third-party:cc",
-        "//third-party:codespan-reporting",
         "//third-party:link-cplusplus",
-        "//third-party:proc-macro2",
-        "//third-party:quote",
-        "//third-party:syn",
     ],
 )
 
 rust_binary(
     name = "codegen",
-    srcs = glob(["cmd/src/**/*.rs"]),
-    data = ["cmd/src/gen/include/cxx.h"],
+    srcs = glob(["gen/cmd/src/**/*.rs"]),
+    data = ["gen/cmd/src/gen/include/cxx.h"],
     visibility = ["//visibility:public"],
     deps = [
         "//third-party:anyhow",
@@ -57,3 +50,18 @@ rust_library(
         "//third-party:syn",
     ],
 )
+
+rust_library(
+    name = "build",
+    srcs = glob(["gen/build/src/**/*.rs"]),
+    data = ["gen/build/src/gen/include/cxx.h"],
+    visibility = ["//visibility:public"],
+    deps = [
+        "//third-party:anyhow",
+        "//third-party:cc",
+        "//third-party:codespan-reporting",
+        "//third-party:proc-macro2",
+        "//third-party:quote",
+        "//third-party:syn",
+    ],
+)
diff --git a/Cargo.toml b/Cargo.toml
index a47a842..ea97712 100644
--- a/Cargo.toml
+++ b/Cargo.toml
@@ -15,25 +15,20 @@ exclude = ["/demo-cxx", "/gen", "/syntax", "/third-party"]
 travis-ci = { repository = "dtolnay/cxx" }
 
 [dependencies]
-anyhow = "1.0"
-cc = "1.0.49"
-codespan-reporting = "0.9"
 cxxbridge-macro = { version = "=0.2.12", path = "macro" }
 link-cplusplus = "1.0"
-proc-macro2 = { version = "1.0", features = ["span-locations"] }
-quote = "1.0"
-syn = { version = "1.0", features = ["full"] }
 
 [build-dependencies]
 cc = "1.0.49"
 
 [dev-dependencies]
+cxx-build = { version = "=0.2.12", path = "gen/build" }
 cxx-test-suite = { version = "0", path = "tests/ffi" }
 rustversion = "1.0"
 trybuild = { version = "1.0.21", features = ["diff"] }
 
 [workspace]
-members = ["cmd", "demo-rs", "macro", "tests/ffi"]
+members = ["demo-rs", "gen/build", "gen/cmd", "macro", "tests/ffi"]
 
 [package.metadata.docs.rs]
 targets = ["x86_64-unknown-linux-gnu"]
diff --git a/demo-rs/Cargo.toml b/demo-rs/Cargo.toml
index f7e7f84..d2147ab 100644
--- a/demo-rs/Cargo.toml
+++ b/demo-rs/Cargo.toml
@@ -9,4 +9,4 @@ publish = false
 cxx = { path = ".." }
 
 [build-dependencies]
-cxx = { path = ".." }
+cxx-build = { path = "../gen/build" }
diff --git a/demo-rs/build.rs b/demo-rs/build.rs
index 71def71..edbb281 100644
--- a/demo-rs/build.rs
+++ b/demo-rs/build.rs
@@ -1,6 +1,5 @@
 fn main() {
-    cxx::Build::new()
-        .bridge("src/main.rs")
+    cxx_build::bridge("src/main.rs")
         .file("../demo-cxx/demo.cc")
         .flag("-std=c++11")
         .compile("cxxbridge-demo");
diff --git a/gen/build/Cargo.toml b/gen/build/Cargo.toml
new file mode 100644
index 0000000..3552524
--- /dev/null
+++ b/gen/build/Cargo.toml
@@ -0,0 +1,22 @@
+[package]
+name = "cxx-build"
+version = "0.2.12"
+authors = ["David Tolnay <dtolnay@gmail.com>"]
+edition = "2018"
+license = "MIT OR Apache-2.0"
+description = "C++ code generator for integrating `cxx` crate into a Cargo build."
+repository = "https://github.com/dtolnay/cxx"
+
+[badges]
+travis-ci = { repository = "dtolnay/cxx" }
+
+[dependencies]
+anyhow = "1.0"
+cc = "1.0.49"
+codespan-reporting = "0.9"
+proc-macro2 = { version = "1.0", features = ["span-locations"] }
+quote = "1.0"
+syn = { version = "1.0", features = ["full"] }
+
+[package.metadata.docs.rs]
+targets = ["x86_64-unknown-linux-gnu"]
diff --git a/gen/build/LICENSE-APACHE b/gen/build/LICENSE-APACHE
new file mode 120000
index 0000000..1cd601d
--- /dev/null
+++ b/gen/build/LICENSE-APACHE
@@ -0,0 +1 @@
+../../LICENSE-APACHE
\ No newline at end of file
diff --git a/gen/build/LICENSE-MIT b/gen/build/LICENSE-MIT
new file mode 120000
index 0000000..b2cfbdc
--- /dev/null
+++ b/gen/build/LICENSE-MIT
@@ -0,0 +1 @@
+../../LICENSE-MIT
\ No newline at end of file
diff --git a/gen/build/src/error.rs b/gen/build/src/error.rs
new file mode 100644
index 0000000..740ab94
--- /dev/null
+++ b/gen/build/src/error.rs
@@ -0,0 +1,37 @@
+use std::error::Error as StdError;
+use std::fmt::{self, Display};
+use std::io;
+
+pub(super) type Result<T, E = Error> = std::result::Result<T, E>;
+
+#[derive(Debug)]
+pub(super) enum Error {
+    MissingOutDir,
+    TargetDir,
+    Io(io::Error),
+}
+
+impl Display for Error {
+    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
+        match self {
+            Error::MissingOutDir => write!(f, "missing OUT_DIR environment variable"),
+            Error::TargetDir => write!(f, "failed to locate target dir"),
+            Error::Io(err) => err.fmt(f),
+        }
+    }
+}
+
+impl StdError for Error {
+    fn source(&self) -> Option<&(dyn StdError + 'static)> {
+        match self {
+            Error::Io(err) => Some(err),
+            _ => None,
+        }
+    }
+}
+
+impl From<io::Error> for Error {
+    fn from(err: io::Error) -> Self {
+        Error::Io(err)
+    }
+}
diff --git a/gen/build/src/gen b/gen/build/src/gen
new file mode 120000
index 0000000..929cb3d
--- /dev/null
+++ b/gen/build/src/gen
@@ -0,0 +1 @@
+../../src
\ No newline at end of file
diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
new file mode 100644
index 0000000..5bee67f
--- /dev/null
+++ b/gen/build/src/lib.rs
@@ -0,0 +1,96 @@
+//! The CXX code generator for constructing and compiling C++ code.
+//!
+//! This is intended to be used from Cargo build scripts to execute CXX's
+//! C++ code generator, set up any additional compiler flags depending on
+//! the use case, and make the C++ compiler invocation.
+//!
+//! <br>
+//!
+//! # Example
+//!
+//! Example of a canonical Cargo build script that builds a CXX bridge:
+//!
+//! ```no_run
+//! // build.rs
+//!
+//! fn main() {
+//!     cxx_build::bridge("src/main.rs")
+//!         .file("../demo-cxx/demo.cc")
+//!         .flag("-std=c++11")
+//!         .compile("cxxbridge-demo");
+//!
+//!     println!("cargo:rerun-if-changed=src/main.rs");
+//!     println!("cargo:rerun-if-changed=../demo-cxx/demo.h");
+//!     println!("cargo:rerun-if-changed=../demo-cxx/demo.cc");
+//! }
+//! ```
+//!
+//! A runnable working setup with this build script is shown in the
+//! *demo-rs* and *demo-cxx* directories of [https://github.com/dtolnay/cxx].
+//!
+//! [https://github.com/dtolnay/cxx]: https://github.com/dtolnay/cxx
+//!
+//! <br>
+//!
+//! # Alternatives
+//!
+//! For use in non-Cargo builds like Bazel or Buck, CXX provides an
+//! alternate way of invoking the C++ code generator as a standalone command
+//! line tool. The tool is packaged as the `cxxbridge-cmd` crate.
+//!
+//! ```bash
+//! $ cargo install cxxbridge-cmd  # or build it from the repo
+//!
+//! $ cxxbridge src/main.rs --header > path/to/mybridge.h
+//! $ cxxbridge src/main.rs > path/to/mybridge.cc
+//! ```
+
+mod error;
+mod gen;
+mod paths;
+mod syntax;
+
+use crate::error::Result;
+use crate::gen::Opt;
+use anyhow::anyhow;
+use std::fs;
+use std::io::{self, Write};
+use std::path::Path;
+use std::process;
+
+/// This returns a [`cc::Build`] on which you should continue to set up any
+/// additional source files or compiler flags, and lastly call its [`compile`]
+/// method to execute the C++ build.
+///
+/// [`compile`]: https://docs.rs/cc/1.0.49/cc/struct.Build.html#method.compile
+#[must_use]
+pub fn bridge(rust_source_file: impl AsRef<Path>) -> cc::Build {
+    match try_generate_bridge(rust_source_file.as_ref()) {
+        Ok(build) => build,
+        Err(err) => {
+            let _ = writeln!(io::stderr(), "\n\ncxxbridge error: {:?}\n\n", anyhow!(err));
+            process::exit(1);
+        }
+    }
+}
+
+fn try_generate_bridge(rust_source_file: &Path) -> Result<cc::Build> {
+    let header = gen::do_generate_header(rust_source_file, Opt::default());
+    let header_path = paths::out_with_extension(rust_source_file, ".h")?;
+    fs::create_dir_all(header_path.parent().unwrap())?;
+    fs::write(&header_path, header)?;
+    paths::symlink_header(&header_path, rust_source_file);
+
+    let bridge = gen::do_generate_bridge(rust_source_file, Opt::default());
+    let bridge_path = paths::out_with_extension(rust_source_file, ".cc")?;
+    fs::write(&bridge_path, bridge)?;
+    let mut build = paths::cc_build();
+    build.file(&bridge_path);
+
+    let ref cxx_h = paths::include_dir()?.join("rust").join("cxx.h");
+    let _ = fs::create_dir_all(cxx_h.parent().unwrap());
+    let _ = fs::remove_file(cxx_h);
+    let _ = fs::write(cxx_h, gen::include::HEADER);
+
+    Ok(build)
+}
diff --git a/gen/build/src/paths.rs b/gen/build/src/paths.rs
new file mode 100644
index 0000000..ca183d9
--- /dev/null
+++ b/gen/build/src/paths.rs
@@ -0,0 +1,116 @@
+use crate::error::{Error, Result};
+use std::env;
+use std::fs;
+use std::path::{Path, PathBuf};
+
+fn out_dir() -> Result<PathBuf> {
+    env::var_os("OUT_DIR")
+        .map(PathBuf::from)
+        .ok_or(Error::MissingOutDir)
+}
+
+pub(crate) fn cc_build() -> cc::Build {
+    try_cc_build().unwrap_or_default()
+}
+
+fn try_cc_build() -> Result<cc::Build> {
+    let mut build = cc::Build::new();
+    build.include(include_dir()?);
+    build.include(target_dir()?.parent().unwrap());
+    Ok(build)
+}
+
+// Symlink the header file into a predictable place. The header generated from
+// path/to/mod.rs gets linked to targets/cxxbridge/path/to/mod.rs.h.
+pub(crate) fn symlink_header(path: &Path, original: &Path) {
+    let _ = try_symlink_header(path, original);
+}
+
+fn try_symlink_header(path: &Path, original: &Path) -> Result<()> {
+    let suffix = relative_to_parent_of_target_dir(original)?;
+    let ref dst = include_dir()?.join(suffix);
+
+    fs::create_dir_all(dst.parent().unwrap())?;
+    let _ = fs::remove_file(dst);
+    symlink_or_copy(path, dst)?;
+
+    let mut file_name = dst.file_name().unwrap().to_os_string();
+    file_name.push(".h");
+    let ref dst2 = dst.with_file_name(file_name);
+    symlink_or_copy(path, dst2)?;
+
+    Ok(())
+}
+
+fn relative_to_parent_of_target_dir(original: &Path) -> Result<PathBuf> {
+    let target_dir = target_dir()?;
+    let mut outer = target_dir.parent().unwrap();
+    let original = canonicalize(original)?;
+    loop {
+        if let Ok(suffix) = original.strip_prefix(outer) {
+            return Ok(suffix.to_owned());
+        }
+        match outer.parent() {
+            Some(parent) => outer = parent,
+            None => return Ok(original.components().skip(1).collect()),
+        }
+    }
+}
+
+pub(crate) fn out_with_extension(path: &Path, ext: &str) -> Result<PathBuf> {
+    let mut file_name = path.file_name().unwrap().to_owned();
+    file_name.push(ext);
+
+    let out_dir = out_dir()?;
+    let rel = relative_to_parent_of_target_dir(path)?;
+    Ok(out_dir.join(rel).with_file_name(file_name))
+}
+
+pub(crate) fn include_dir() -> Result<PathBuf> {
+    let target_dir = target_dir()?;
+    Ok(target_dir.join("cxxbridge"))
+}
+
+fn target_dir() -> Result<PathBuf> {
+    let mut dir = out_dir().and_then(canonicalize)?;
+    loop {
+        if dir.ends_with("target") {
+            return Ok(dir);
+        }
+        if !dir.pop() {
+            return Err(Error::TargetDir);
+        }
+    }
+}
+
+#[cfg(not(windows))]
+fn canonicalize(path: impl AsRef<Path>) -> Result<PathBuf> {
+    Ok(fs::canonicalize(path)?)
+}
+
+#[cfg(windows)]
+fn canonicalize(path: impl AsRef<Path>) -> Result<PathBuf> {
+    // Real fs::canonicalize on Windows produces UNC paths which cl.exe is
+    // unable to handle in includes. Use a poor approximation instead.
+    // https://github.com/rust-lang/rust/issues/42869
+    // https://github.com/alexcrichton/cc-rs/issues/169
+    Ok(env::current_dir()?.join(path))
+}
+
+#[cfg(unix)]
+use std::os::unix::fs::symlink as symlink_or_copy;
+
+#[cfg(windows)]
+fn symlink_or_copy(src: &Path, dst: &Path) -> Result<()> {
+    use std::os::windows::fs::symlink_file;
+
+    // Pre-Windows 10, symlinks require admin privileges. Since Windows 10, they
+    // require Developer Mode. If it fails, fall back to copying the file.
+    if symlink_file(src, dst).is_err() {
+        fs::copy(src, dst)?;
+    }
+    Ok(())
+}
+
+#[cfg(not(any(unix, windows)))]
+use std::fs::copy as symlink_or_copy;
diff --git a/gen/build/src/syntax b/gen/build/src/syntax
new file mode 120000
index 0000000..a6fe06c
--- /dev/null
+++ b/gen/build/src/syntax
@@ -0,0 +1 @@
+../../../syntax
\ No newline at end of file
diff --git a/gen/cmd/Cargo.toml b/gen/cmd/Cargo.toml
new file mode 100644
index 0000000..742d54b
--- /dev/null
+++ b/gen/cmd/Cargo.toml
@@ -0,0 +1,26 @@
+[package]
+name = "cxxbridge-cmd"
+version = "0.2.12"
+authors = ["David Tolnay <dtolnay@gmail.com>"]
+edition = "2018"
+license = "MIT OR Apache-2.0"
+description = "C++ code generator for integrating `cxx` crate into a non-Cargo build."
+repository = "https://github.com/dtolnay/cxx"
+
+[[bin]]
+name = "cxxbridge"
+path = "src/main.rs"
+
+[badges]
+travis-ci = { repository = "dtolnay/cxx" }
+
+[dependencies]
+anyhow = "1.0"
+codespan-reporting = "0.9"
+proc-macro2 = { version = "1.0", features = ["span-locations"] }
+quote = "1.0"
+structopt = "0.3"
+syn = { version = "1.0", features = ["full"] }
+
+[package.metadata.docs.rs]
+targets = ["x86_64-unknown-linux-gnu"]
diff --git a/gen/cmd/LICENSE-APACHE b/gen/cmd/LICENSE-APACHE
new file mode 120000
index 0000000..1cd601d
--- /dev/null
+++ b/gen/cmd/LICENSE-APACHE
@@ -0,0 +1 @@
+../../LICENSE-APACHE
\ No newline at end of file
diff --git a/gen/cmd/LICENSE-MIT b/gen/cmd/LICENSE-MIT
new file mode 120000
index 0000000..b2cfbdc
--- /dev/null
+++ b/gen/cmd/LICENSE-MIT
@@ -0,0 +1 @@
+../../LICENSE-MIT
\ No newline at end of file
diff --git a/gen/cmd/src/gen b/gen/cmd/src/gen
new file mode 120000
index 0000000..929cb3d
--- /dev/null
+++ b/gen/cmd/src/gen
@@ -0,0 +1 @@
+../../src
\ No newline at end of file
diff --git a/gen/cmd/src/lib.rs b/gen/cmd/src/lib.rs
new file mode 100644
index 0000000..8b1a393
--- /dev/null
+++ b/gen/cmd/src/lib.rs
@@ -0,0 +1 @@
+// empty
diff --git a/gen/cmd/src/main.rs b/gen/cmd/src/main.rs
new file mode 100644
index 0000000..a20179f
--- /dev/null
+++ b/gen/cmd/src/main.rs
@@ -0,0 +1,60 @@
+#![allow(
+    clippy::cognitive_complexity,
+    clippy::inherent_to_string,
+    clippy::large_enum_variant,
+    clippy::new_without_default,
+    clippy::toplevel_ref_arg
+)]
+
+mod gen;
+mod syntax;
+
+use gen::include;
+use std::io::{self, Write};
+use std::path::PathBuf;
+use structopt::StructOpt;
+
+#[derive(StructOpt, Debug)]
+#[structopt(
+    name = "cxxbridge",
+    author = "David Tolnay <dtolnay@gmail.com>",
+    about = "https://github.com/dtolnay/cxx",
+    usage = "\
+    cxxbridge <input>.rs              Emit .cc file for bridge to stdout
+    cxxbridge <input>.rs --header     Emit .h file for bridge to stdout
+    cxxbridge --header                Emit rust/cxx.h header to stdout",
+    help_message = "Print help information",
+    version_message = "Print version information"
+)]
+struct Opt {
+    /// Input Rust source file containing #[cxx::bridge]
+    #[structopt(parse(from_os_str), required_unless = "header")]
+    input: Option<PathBuf>,
+
+    /// Emit header with declarations only
+    #[structopt(long)]
+    header: bool,
+
+    /// Any additional headers to #include
+    #[structopt(short, long)]
+    include: Vec<String>,
+}
+
+fn write(content: impl AsRef<[u8]>) {
+    let _ = io::stdout().lock().write_all(content.as_ref());
+}
+
+fn main() {
+    let opt = Opt::from_args();
+
+    let gen = gen::Opt {
+        include: opt.include,
+    };
+
+    match (opt.input, opt.header) {
+        (Some(input), true) => write(gen::do_generate_header(&input, gen)),
+        (Some(input), false) => write(gen::do_generate_bridge(&input, gen)),
+        (None, true) => write(include::HEADER),
+        (None, false) => unreachable!(), // enforced by required_unless
+    }
+}
diff --git a/gen/cmd/src/syntax b/gen/cmd/src/syntax
new file mode 120000
index 0000000..a6fe06c
--- /dev/null
+++ b/gen/cmd/src/syntax
@@ -0,0 +1 @@
+../../../syntax
\ No newline at end of file
diff --git a/gen/src/error.rs b/gen/src/error.rs
new file mode 100644
index 0000000..2e8ecc4
--- /dev/null
+++ b/gen/src/error.rs
@@ -0,0 +1,119 @@
+use crate::syntax;
+use anyhow::anyhow;
+use codespan_reporting::diagnostic::{Diagnostic, Label};
+use codespan_reporting::files::SimpleFiles;
+use codespan_reporting::term::termcolor::{ColorChoice, StandardStream, WriteColor};
+use codespan_reporting::term::{self, Config};
+use std::error::Error as StdError;
+use std::fmt::{self, Display};
+use std::io::{self, Write};
+use std::ops::Range;
+use std::path::Path;
+use std::process;
+
+pub(super) type Result<T, E = Error> = std::result::Result<T, E>;
+
+#[derive(Debug)]
+pub(super) enum Error {
+    NoBridgeMod,
+    OutOfLineMod,
+    Io(io::Error),
+    Syn(syn::Error),
+}
+
+impl Display for Error {
+    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
+        match self {
+            Error::NoBridgeMod => write!(f, "no #[cxx::bridge] module found"),
+            Error::OutOfLineMod => write!(f, "#[cxx::bridge] module must have inline contents"),
+            Error::Io(err) => err.fmt(f),
+            Error::Syn(err) => err.fmt(f),
+        }
+    }
+}
+
+impl StdError for Error {
+    fn source(&self) -> Option<&(dyn StdError + 'static)> {
+        match self {
+            Error::Io(err) => Some(err),
+            Error::Syn(err) => Some(err),
+            _ => None,
+        }
+    }
+}
+
+impl From<io::Error> for Error {
+    fn from(err: io::Error) -> Self {
+        Error::Io(err)
+    }
+}
+
+impl From<syn::Error> for Error {
+    fn from(err: syn::Error) -> Self {
+        Error::Syn(err)
+    }
+}
+
+pub(super) fn format_err(path: &Path, source: &str, error: Error) -> ! {
+    match error {
+        Error::Syn(syn_error) => {
+            let writer = StandardStream::stderr(ColorChoice::Auto);
+            let ref mut stderr = writer.lock();
+            for error in syn_error {
+                let _ = writeln!(stderr);
+                display_syn_error(stderr, path, source, error);
+            }
+        }
+        _ => eprintln!("cxxbridge: {:?}", anyhow!(error)),
+    }
+    process::exit(1);
+}
+
+fn display_syn_error(stderr: &mut dyn WriteColor, path: &Path, source: &str, error: syn::Error) {
+    let span = error.span();
+    let start = span.start();
+    let end = span.end();
+
+    let mut start_offset = 0;
+    for _ in 1..start.line {
+        start_offset += source[start_offset..].find('\n').unwrap() + 1;
+    }
+    start_offset += start.column;
+
+    let mut end_offset = start_offset;
+    if start.line == end.line {
+        end_offset -= start.column;
+    } else {
+        for _ in 0..end.line - start.line {
+            end_offset += source[end_offset..].find('\n').unwrap() + 1;
+        }
+    }
+    end_offset += end.column;
+
+    let mut files = SimpleFiles::new();
+    let file = files.add(path.to_string_lossy(), source);
+
+    let diagnostic = diagnose(file, start_offset..end_offset, error);
+
+    let config = Config::default();
+    let _ = term::emit(stderr, &config, &files, &diagnostic);
+}
+
+fn diagnose(file: usize, range: Range<usize>, error: syn::Error) -> Diagnostic<usize> {
+    let message = error.to_string();
+    let info = syntax::error::ERRORS
+        .iter()
+        .find(|e| message.contains(e.msg));
+    let mut diagnostic = Diagnostic::error().with_message(&message);
+    let mut label = Label::primary(file, range);
+    if let Some(info) = info {
+        label.message = info.label.map_or(message, str::to_owned);
+        diagnostic.labels.push(label);
+        diagnostic.notes.extend(info.note.map(str::to_owned));
+    } else {
+        label.message = message;
+        diagnostic.labels.push(label);
+    }
+    diagnostic.code = Some("cxxbridge".to_owned());
+    diagnostic
+}
diff --git a/gen/src/include b/gen/src/include
new file mode 120000
index 0000000..fcffffb
--- /dev/null
+++ b/gen/src/include
@@ -0,0 +1 @@
+../../include
\ No newline at end of file
diff --git a/gen/src/include.rs b/gen/src/include.rs
new file mode 100644
index 0000000..129a8e6
--- /dev/null
+++ b/gen/src/include.rs
@@ -0,0 +1,106 @@
+use std::fmt::{self, Display};
+
+pub static HEADER: &str = include_str!("include/cxx.h");
+
+pub fn get(guard: &str) -> &'static str {
+    let ifndef = format!("#ifndef {}", guard);
+    let endif = format!("#endif // {}", guard);
+    let begin = find_line(&ifndef);
+    let end = find_line(&endif);
+    if let (Some(begin), Some(end)) = (begin, end) {
+        &HEADER[begin..end + endif.len()]
+    } else {
+        panic!("not found in cxx.h header: {}", guard)
+    }
+}
+
+fn find_line(line: &str) -> Option<usize> {
+    let mut offset = 0;
+    loop {
+        offset += HEADER[offset..].find(line)?;
+        let rest = &HEADER[offset + line.len()..];
+        if rest.starts_with('\n') || rest.starts_with('\r') {
+            return Some(offset);
+        }
+        offset += line.len();
+    }
+}
+
+#[derive(Default, PartialEq)]
+pub struct Includes {
+    custom: Vec<String>,
+    pub array: bool,
+    pub cstddef: bool,
+    pub cstdint: bool,
+    pub cstring: bool,
+    pub exception: bool,
+    pub memory: bool,
+    pub string: bool,
+    pub type_traits: bool,
+    pub utility: bool,
+    pub vector: bool,
+    pub base_tsd: bool,
+}
+
+impl Includes {
+    pub fn new() -> Self {
+        Includes::default()
+    }
+
+    pub fn insert(&mut self, include: String) {
+        self.custom.push(include);
+    }
+}
+
+impl Extend<String> for Includes {
+    fn extend<I: IntoIterator<Item = String>>(&mut self, iter: I) {
+        self.custom.extend(iter);
+    }
+}
+
+impl Display for Includes {
+    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
+        for include in &self.custom {
+            writeln!(f, "#include \"{}\"", include.escape_default())?;
+        }
+        if self.array {
+            writeln!(f, "#include <array>")?;
+        }
+        if self.cstddef {
+            writeln!(f, "#include <cstddef>")?;
+        }
+        if self.cstdint {
+            writeln!(f, "#include <cstdint>")?;
+        }
+        if self.cstring {
+            writeln!(f, "#include <cstring>")?;
+        }
+        if self.exception {
+            writeln!(f, "#include <exception>")?;
+        }
+        if self.memory {
+            writeln!(f, "#include <memory>")?;
+        }
+        if self.string {
+            writeln!(f, "#include <string>")?;
+        }
+        if self.type_traits {
+            writeln!(f, "#include <type_traits>")?;
+        }
+        if self.utility {
+            writeln!(f, "#include <utility>")?;
+        }
+        if self.vector {
+            writeln!(f, "#include <vector>")?;
+        }
+        if self.base_tsd {
+            writeln!(f, "#if defined(_WIN32)")?;
+            writeln!(f, "#include <BaseTsd.h>")?;
+            writeln!(f, "#endif")?;
+        }
+        if *self != Self::default() {
+            writeln!(f)?;
+        }
+        Ok(())
+    }
+}
diff --git a/gen/src/mod.rs b/gen/src/mod.rs
new file mode 100644
index 0000000..928c6ec
--- /dev/null
+++ b/gen/src/mod.rs
@@ -0,0 +1,87 @@
+// Functionality that is shared between the cxx::generate_bridge entry point and
+// the cmd.
+
+mod error;
+pub(super) mod include;
+pub(super) mod out;
+mod write;
+
+use self::error::{format_err, Error, Result};
+use crate::syntax::namespace::Namespace;
+use crate::syntax::{self, check, Types};
+use quote::quote;
+use std::fs;
+use std::path::Path;
+use syn::{Attribute, File, Item};
+
+struct Input {
+    namespace: Namespace,
+    module: Vec<Item>,
+}
+
+#[derive(Default)]
+pub(super) struct Opt {
+    /// Any additional headers to #include
+    pub include: Vec<String>,
+}
+
+pub(super) fn do_generate_bridge(path: &Path, opt: Opt) -> Vec<u8> {
+    let header = false;
+    generate(path, opt, header)
+}
+
+pub(super) fn do_generate_header(path: &Path, opt: Opt) -> Vec<u8> {
+    let header = true;
+    generate(path, opt, header)
+}
+
+fn generate(path: &Path, opt: Opt, header: bool) -> Vec<u8> {
+    let source = match fs::read_to_string(path) {
+        Ok(source) => source,
+        Err(err) => format_err(path, "", Error::Io(err)),
+    };
+    match (|| -> Result<_> {
+        let syntax = syn::parse_file(&source)?;
+        let bridge = find_bridge_mod(syntax)?;
+        let apis = syntax::parse_items(bridge.module)?;
+        let types = Types::collect(&apis)?;
+        check::typecheck(&apis, &types)?;
+        let out = write::gen(bridge.namespace, &apis, &types, opt, header);
+        Ok(out)
+    })() {
+        Ok(out) => out.content(),
+        Err(err) => format_err(path, &source, err),
+    }
+}
+
+fn find_bridge_mod(syntax: File) -> Result<Input> {
+    for item in syntax.items {
+        if let Item::Mod(item) = item {
+            for attr in &item.attrs {
+                let path = &attr.path;
+                if quote!(#path).to_string() == "cxx :: bridge" {
+                    let module = match item.content {
+                        Some(module) => module.1,
+                        None => {
+                            return Err(Error::Syn(syn::Error::new_spanned(
+                                item,
+                                Error::OutOfLineMod,
+                            )));
+                        }
+                    };
+                    let namespace = parse_args(attr)?;
+                    return Ok(Input { namespace, module });
+                }
+            }
+        }
+    }
+    Err(Error::NoBridgeMod)
+}
+
+fn parse_args(attr: &Attribute) -> syn::Result<Namespace> {
+    if attr.tokens.is_empty() {
+        Ok(Namespace::none())
+    } else {
+        attr.parse_args()
+    }
+}
diff --git a/gen/src/out.rs b/gen/src/out.rs
new file mode 100644
index 0000000..08bf85f
--- /dev/null
+++ b/gen/src/out.rs
@@ -0,0 +1,91 @@
+use crate::gen::include::Includes;
+use crate::syntax::namespace::Namespace;
+use std::cell::RefCell;
+use std::fmt::{self, Arguments, Write};
+
+pub(crate) struct OutFile {
+    pub namespace: Namespace,
+    pub header: bool,
+    pub include: Includes,
+    content: RefCell<Content>,
+}
+
+struct Content {
+    bytes: Vec<u8>,
+    section_pending: bool,
+    blocks_pending: Vec<&'static str>,
+}
+
+impl OutFile {
+    pub fn new(namespace: Namespace, header: bool) -> Self {
+        OutFile {
+            namespace,
+            header,
+            include: Includes::new(),
+            content: RefCell::new(Content {
+                bytes: Vec::new(),
+                section_pending: false,
+                blocks_pending: Vec::new(),
+            }),
+        }
+    }
+
+    // Write a blank line if the preceding section had any contents.
+    pub fn next_section(&mut self) {
+        let content = self.content.get_mut();
+        content.section_pending = true;
+    }
+
+    pub fn begin_block(&mut self, block: &'static str) {
+        let content = self.content.get_mut();
+        content.blocks_pending.push(block);
+    }
+
+    pub fn end_block(&mut self, block: &'static str) {
+        let content = self.content.get_mut();
+        if content.blocks_pending.pop().is_none() {
+            content.bytes.extend_from_slice(b"} // ");
+            content.bytes.extend_from_slice(block.as_bytes());
+            content.bytes.push(b'\n');
+            content.section_pending = true;
+        }
+    }
+
+    pub fn prepend(&mut self, section: String) {
+        let content = self.content.get_mut();
+        content.bytes.splice(..0, section.into_bytes());
+    }
+
+    pub fn write_fmt(&self, args: Arguments) {
+        let content = &mut *self.content.borrow_mut();
+        Write::write_fmt(content, args).unwrap();
+    }
+
+    pub fn content(&self) -> Vec<u8> {
+        self.content.borrow().bytes.clone()
+    }
+}
+
+impl Write for Content {
+    fn write_str(&mut self, s: &str) -> fmt::Result {
+        if !s.is_empty() {
+            if !self.blocks_pending.is_empty() {
+                if !self.bytes.is_empty() {
+                    self.bytes.push(b'\n');
+                }
+                for block in self.blocks_pending.drain(..) {
+                    self.bytes.extend_from_slice(block.as_bytes());
+                    self.bytes.extend_from_slice(b" {\n");
+                }
+                self.section_pending = false;
+            } else if self.section_pending {
+                if !self.bytes.is_empty() {
+                    self.bytes.push(b'\n');
+                }
+                self.section_pending = false;
+            }
+            self.bytes.extend_from_slice(s.as_bytes());
+        }
+        Ok(())
+    }
+}
